/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MAPIMPRLOJA                                              */
/* Tabela : Mapeamento da impressora por loja                                 */
/*                                                                            */
/* Criao:                                                                   */
/* 28/01/2013 - Leonardo Matos                                                */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_MAPIMPRLOJA
BEFORE INSERT OR UPDATE OR DELETE
ON MAPIMPRLOJA FOR EACH ROW
BEGIN

   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MAPIMPRLOJA',:OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDLOJA='||:OLD.CDLOJA||';CDPORTAIMPR='||:OLD.CDPORTAIMPR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MAPIMPRLOJA MODIFY DTULTATU DEFAULT SYSDATE
/

UPDATE MAPIMPRLOJA SET DTULTATU = SYSDATE WHERE DTULTATU IS NULL
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_MAPIMPRLOJA','5.50.000'); END;
/

