const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../json/leitorJson.po.js');
const auditoresIndependentes = require('../../../page-objects/parametrizacao/contabil/auditoresIndependentes.po.js');
const auditoresGridId = '94727812623956744902473';
describe('Tela Auditores Independentes', () => {
	beforeEach(() => {
		browser.get('http://erpteste.teknisa.com/login/');
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		auditoresIndependentes.abrir();
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${auditoresGridId}`)));
	});

	afterEach(() => {
		geral.sair();
	});
	it('Deve acessar a tela Auditores Independentes', () => {
		expect(z.component.header.getTitle()).toBe('Auditores Independentes');
	});

	it('Deve adicionar um auditor independente', () => {
		geral.clickAdicionar();
		auditoresIndependentes.adicionar(j.getValor('nomeRepresentante'), j.getValor('registroCVM'));
		geral.clickSalvar();
		geral.filterIt(j.getValor('nomeRepresentante'));
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${auditoresGridId}`)));

		expect(geral.gridHasText(auditoresGridId, j.getValor('nomeRepresentante')))
			.toBe(j.getValor('nomeRepresentante'));
	});

	it('Deve adicionar Empresa Relacionada', () => {
		geral.clickGrid('NMAUDITOR', j.getValor('nomeRepresentante'), auditoresGridId);
		geral.trocarAba('Empresas Relacionadas');
		geral.clickAdicionar();
		auditoresIndependentes.adicionarEmpresaRelacionada(j.getValor('razaoSocial'));
		geral.clickSalvar();
		protractorHelper.waitForElementVisibility(element(by.id('grid-94727812616596601702474')));

		expect(geral.gridHasText('94727812616596601702474', j.getValor('razaoSocial'), 1))
			.toBe(j.getValor('razaoSocial'));
	});

	it('Editar registro adicionado', () => {
		geral.clickGrid('NMAUDITOR', j.getValor('nomeRepresentante'), auditoresGridId);
		geral.clickEditar();
		auditoresIndependentes.editar(j.getValor('nomeRepresentante1'), j.getValor('registroCVM1'));
		geral.clickSalvar();
		geral.clickVoltar();
		geral.filterIt(j.getValor('nomeRepresentante1'));
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${auditoresGridId}`)));

		expect(geral.gridHasText(auditoresGridId, j.getValor('nomeRepresentante1')))
			.toBe(j.getValor('nomeRepresentante1'));
	});

	it('Excluir registro', () => {
		geral.clickGrid('NMAUDITOR', j.getValor('nomeRepresentante1'), auditoresGridId);
		geral.clickExcluir();
		geral.clickSim();
		geral.filterIt(j.getValor('nomeRepresentante1'));
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${auditoresGridId}`)));

		expect(geral.gridHasText(auditoresGridId, j.getValor('nomeRepresentante1')))
			.toBeUndefined();
	});
});
